//+------------------------------------------------------------------+
//|                                            Position Close By.mq5 |
//|                        Copyright 2020, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2020, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property description "The opposite close at the current symbol."
#property description "Magic Number is not counted - it is cloned when closed."
//---
#define EQUAL 0
#define LESS -1
#define MORE 1
#include <Object.mqh>
#include <Arrays\ArrayObj.mqh>
/*
   barabashkakvn Trading engine 3.138
*/
#include <Trade\PositionInfo.mqh>
#include <Trade\Trade.mqh>
#include <Trade\SymbolInfo.mqh>
//---
CPositionInfo  m_position;                   // object of CPositionInfo class
CTrade         m_trade;                      // object of CTrade class
CSymbolInfo    m_symbol;                     // object of CSymbolInfo class
//--- input parameters
input int      Input1=9;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum ENUM_SORT_TYPE
  {
   SORT_BY_VOLUME,
   SORT_BY_TICKET
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CLineTable: public CObject
  {
private:
   ulong             m_ticket;
   double            m_volume;
public:
                     CLineTable();
                     CLineTable(ulong ticket,double volume)
     {
      m_ticket=ticket;
      m_volume=volume;
     }
   ulong             Ticket()const {return m_ticket;}
   double            Volume()const {return m_volume;}
   virtual int       Compare(const CObject *node,const int mode=0) const
     {
      const CLineTable* line=node;
      switch(mode)
        {
         case SORT_BY_VOLUME:
            if(line.Volume()==this.Volume())
               return EQUAL;
            else
               if(line.Volume()<this.Volume())
                  return MORE;
               else
                  return LESS;
         case SORT_BY_TICKET:
            if(line.Ticket()==this.Ticket())
               return EQUAL;
            else
               if(line.Ticket()<this.Ticket())
                  return MORE;
               else
                  return LESS;
        }
      return EQUAL;
     }
  };
CArrayObj TableBuy;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//--- add BUY positions to the table
   Print(EnumToString(SORT_BY_TICKET));
   TableBuy.Sort(SORT_BY_TICKET);
   for(int i=PositionsTotal()-1; i>=0; i--)
      if(m_position.SelectByIndex(i)) // selects the position by index for further access to its properties
         if(m_position.Symbol()==Symbol())
            if(m_position.PositionType()==POSITION_TYPE_BUY)
               TableBuy.InsertSort(new CLineTable(m_position.Ticket(),m_position.Volume()));
//--- let's see what happened:
   for(int i=0; i<TableBuy.Total(); i++)
     {
      CLineTable* line=TableBuy.At(i);
      printf(IntegerToString(line.Ticket()) + "\t" + DoubleToString(line.Volume(),2));
     }
//--- sort by the second factor: volume
   Print(EnumToString(SORT_BY_VOLUME));
   TableBuy.Sort(SORT_BY_VOLUME);
//--- let's see what happened:
   for(int i=0; i<TableBuy.Total(); i++)
     {
      CLineTable* line=TableBuy.At(i);
      printf(IntegerToString(line.Ticket()) + "\t" + DoubleToString(line.Volume(),2));
     }
   TableBuy.Clear();
//---
   ExpertRemove();
  }
//+------------------------------------------------------------------+
